#ifndef _GC_H
#define _GC_H


typedef long	MEM;	/* the contents of a memory cell */
typedef MEM*	PTR;	/* a pointer to a memory cell */
			/* essential requirement: sizeof(PTR)<=sizeof(CELL) */
typedef long	ATOM;	/* atomic objects... */



#if defined(CDR_CODING)

#error "not implemented yet"

#else /* default encoding */

#define MEM_ENCODING	ME_PARITY

#define ATOMBITS	31
#define ATOM_PARITY	1		/* atoms have parity bit set to 1 */
#define PTR_PARITY	0		/* pointers have parity bit set to 0 */
#define IS_PTR(x)	((x&1)==PTR_PARITY)
#define IS_ATOM(x)	((x&1)==ATOM_PARITY)
#define PTR_of_MEM(x)	((PTR) (x-PTR_PARITY))
#define ATOM_of_MEM(x)	((ATOM) (x>>1))
#define MEM_of_PTR(x)	(((MEM)x)+PTR_PARITY)
#define MEM_of_ATOM(x)	((((MEM)x)<<1)+ATOMBIT)

#endif

#define M2P(x) PTR_of_MEM(x)
#define P2M(x) MEM_of_PTR(x)


void dump_ptrs(void);   /* Dump the pointers (for debugging)                 */
void error(char *);


/* CONS CELLS */
typedef MEM cell[2] ;
#define __CAR(x) (x[0])
#define __CDR(x) (x[1])
#define __RPLACA(x,y) (x[0]=y)
#define __RPLACD(x,y) (x[1]=y)


extern PTR fromspace;
extern PTR tospace;
extern int space_size;
extern PTR bottom;
extern PTR top;
extern PTR scanptr;
extern PTR _bottom;
extern PTR _top;

extern int k;

void flip(void);

inline PTR move_ptr(PTR p);
inline MEM move_mem(MEM p);
inline PTR copy_cell(PTR p);

#define MOVE(p) (p=move_mem(p))

inline PTR cons(MEM car, MEM cdr);
inline MEM car(PTR p);
inline MEM cdr(PTR p);
inline int atom(MEM p);
inline int eq(MEM x, MEM y);
inline void rplaca(PTR x, MEM y);
inline void rplacd(PTR x, MEM y);


#define SWAP(a,b)	({typeof(a) t; t=a; a=b; b=t;})



#endif /* _GC_H */
